#!tkFvwm
#
# bar.tcl
#         A sample tkfvwm module. Imits the Win95 icon bar.
# to use change the first line to the correct tkfvwm path
# Copyright (C) 1995 Andres Aravena (andres@aravena.mic.cl)
#

proc tick {w hour min} {
    incr min
    if {$min>=60} {
	set min 0
	incr hour
	if {$hour>=24} {
	    set hour 0
	}
    }
    $w configure -text [format "%02d:%02d" $hour $min]
    after 60000 tick $w $hour $min
}

proc clock {w time} {
    set hour [lindex $time 0]
    set min [lindex $time 1]
    label $w -text [format "%02d:%02d" $hour $min] -bd 2 \
	    -relief sunken -width 10 -anchor c
    after [lindex $time 2]000 tick .ck $hour $min
}

proc getTime {} {
    set time [lindex [exec date] 3]
    scan $time "%d:%d:%d" hour min sec
    return [concat $hour $min $sec]
}

proc ButtonCommand {id} {
    global Wiconic
    if {$Wiconic($id)} {
	fvwm send  $id {Iconify ""}
	flush stdout
	return
    }
    fvwm send $id {Focus ""}
    flush stdout
}

proc Configure {id flag} {
    global W index Wiconic
    if {($flag & 262144) == 262144} {
	return 
    }
    if {![info exists W($id)]} {
	set W($id) [button .l$index -command "ButtonCommand $id" ]
	set Wiconic($id) 0
	pack $W($id) -side left -padx 2 -pady 2 -fill x
	incr index
    }
    return
}

proc icon_name {id name} {
    global Wname W
    set Wname($id) $name
    if [info exists W($id)] {
	$W($id) configure -text $name
    }
}

proc Destroy_win {id} {
    global W Wname Wiconic active
    if [info exists W($id)] {
	catch {destroy $W($id)}
	unset W($id)
	unset Wname($id)
	unset Wiconic($id)
    }
}

proc iconify {id} {
    global W Wiconic
    if [info exists W($id)] {
	set Wiconic($id) 1
	$W($id) configure -font -adobe-helvetica-medium-r-normal--12-*
    }
}

proc deiconify {id} {
    global W Wiconic
    if [info exists W($id)] {
	$W($id) configure -font -adobe-helvetica-bold-r-normal--12-*
	set Wiconic($id) 0
    }
}

proc Focus {id} {
    global W active
    if {$active!=""} {
	catch {$active configure -relief raised -bg grey60}
    }
    if [info exists W($id)] {
	set active $W($id)
	$active configure -relief sunken -bg grey
    } else {
	set active ""
    }
}

tk appname GoodStuff
option add *highlightThickness 0 
option add *background Grey60
option add *activeBackground grey60
option add *padY 2
option add *padX 2
option add *anchor sw
option add *width 10

set index 0
set active {}

wm geometry . [winfo screenwidth .]x27+0+0
. configure -background grey60

menubutton .menu -text Menu -relief raised -menu .menu.m
pack .menu  -side left -padx 2 -pady 2 -fill y
menu .menu.m -tearoff no
.menu.m add command -label "Close Bar" -command exit
.menu.m add command -label "Restart Fvwm" -command {fvwm send 0 {Restart ""}}
.menu.m add command -label "End Session" \
	-command {fvwm send 0 {Restart "" /usr/local/bin/kill_em}}

clock .ck [getTime]
pack .ck -side right -padx 4 -pady 2 -fill y

fvwm init [lindex $argv 0] [lindex $argv 1]
fvwm configureWindow {Configure %W %f}
fvwm iconName {icon_name %W %N}
fvwm destroyWindow {Destroy_win %W}
fvwm iconify {iconify %W}
fvwm deiconify {deiconify %W}
fvwm FocusChange {Focus %W}
fvwm send 0 Send_WindowList


